from run import Module, NullTask, RenderTask, FindVar, ValueVar
#TODO: Nosetests import issue
from run.task import module
from . import docs, tests

class ManageModule(Module):
    
    #Modules
    
    docs = docs.ManageModule()
    tests = tests.ManageModule()
    
    #Tasks
    
    build = NullTask(
        require=[
            'build_gitignore',                 
            'build_travis',
            'build_manifest',
            'build_readme',
            'build_requirements',
            'build_setup',
            #TODO: fix in run
            #'docs.build',                                                            
        ],
    )
             
    build_gitignore = RenderTask(
        source='_sources/.gitignore',
        target='.gitignore',        
    )
    
    build_travis = RenderTask(
        source='_sources/.travis.yml',
        target='.travis.yml',
    )
    
    build_manifest = RenderTask(
        source='_sources/MANIFEST.in',
        target='MANIFEST.in',
    )            
    
    build_readme = RenderTask(
        source='_sources/README.rst',
        target='README.rst',
    ) 
    
    build_requirements = RenderTask(
        source='_sources/requirements.txt',
        target='requirements.txt',
    ) 
    
    build_setup = RenderTask(
        source='_sources/setup.tpl',
        target='setup.py',
    )
    
    #Vars
     
    long_description = FindVar(
        filepath='README.rst',
        getfirst=True,
    )
    
    pypi_name = ValueVar(
        value=module().name,
    )
    
    version = FindVar(
        mode='objects',
        objname='version',
        filepath='*/version.py',
        getfirst=True,
    )